
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxCoreGblSub.h */


#if !defined(BX_COREGBLSUB_H)
#define BX_COREGBLSUB_H

#include "bxCore.h"
#include "bxCoreSub.h"			// <--
#include "bxOrgTo3D.h"
#include "bxRect.h"
#include "bxTri.h"
#include "bxEdge.h"
#include "bxSurface.h"
#include "bxVector.h"


namespace NameBeziex {
	BxCoreSub*  GBxCoreSub();	// <--
	BxOrgTo3D*  GBxOrgTo3D();
	BxRect*     GBxRect();
	BxTri*      GBxTri();
	BxEdge*     GBxEdge();
	BxSurface*  GBxSurface();
	BxVector*   GBxVector();
};


class BxCoreGblInfo {
public:
	BxCore*     fCore;
	BxCoreSub*  fCoreSub;		// <--
	BxOrgTo3D*  fOrgTo3D;
	BxRect*     fRect;
	BxTri*      fTri;
	BxEdge*     fEdge;
	BxSurface*  fSurface;
	BxVector*   fVector;

public:
	BxCoreGblInfo();
	~BxCoreGblInfo();
};


// -----

class BxCoreGbl {
public:
	BxCoreGblInfo*  fInfo;

public:
	BxCoreGbl();
	virtual ~BxCoreGbl();
};


// -----

namespace NameBeziex {
	BxCore*     GBxCore();
	BxCoreGbl*  GBxCoreGbl();

	typedef  BxCoreGbl* ( *FuncGBxCoreGbl )();

	void
	DefaultGBxCoreGbl();
	void
	OptionGBxCoreGbl( FuncGBxCoreGbl func );
};


#endif  // !defined(BX_COREGBLSUB_H)

////////
