
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxRect.h */


#if !defined( BX_RECT_H )
#define BX_RECT_H

#include "bxCore.h"
#include "bxSurface.h"


class BxRect {
public:
	BxErr
	ConvSurface( const BxCore::SurfaceInfoVertex vertex[ 4 ], BxCore::RectPatchInfo& rect );

	void
	RectToPatch4774( const BxCore::RectPatchInfo& rect, BxSurface::Patch4774& patch );
	void
	RectToPatch4774T( const BxCore::RectPatchInfo& rect, BxSurface::Patch4774& patch );
	void
	PosSurface( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& pos );
	void
	NormalSurface( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& normalVec );
	void
	DuSurface( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& du );
	void
	DvSurface( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& dv );

	void
	InitDiv( const int numDiv, BxCore::DivRect& dst );
	BxErr
	Divide( const BxCore::RectPatchInfo& src, BxCore::DivRect& dst );

private:
	void
	PosSurfaceMain( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& pos );
	void
	PosSurfaceU( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& posU );
	void
	PosSurfaceV( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& posV );
	void
	DuSurfaceMain( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& du );
	void
	DuSurfaceU( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& vecU );
	void
	DuSurfaceV( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& vecV );
	void
	DvSurfaceMain( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& dv );
	void
	DvSurfaceU( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& vecU );
	void
	DvSurfaceV( const BxCore::RectPatchInfo& rect, const BxVec2& uv, BxVec3& vecV );

	void
	InitDivFaceBound( const int numDiv, BxCore::InfoDivRect& rect );
	void
	InitDivFaceIn( const int numDiv, BxCore::InfoDivRect& rect );
	void
	DivideBound( const BxCore::RectPatchInfo& src, BxCore::DivRect& dst );
	void
	DivideIn( const BxCore::RectPatchInfo& src, BxCore::DivRect& dst );
	void
	DivideOne( const BxCore::RectPatchInfo& src, const double u, const double v, BxVec3& pos,
		const int numNormal, BxCore::DivVertexFace vertexFace[], BxCore::DivFaceRect face[] );
};


#endif // #if !defined( BX_RECT_H )

////////
