
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxSurfaceErrChk.h */


#if !defined( BX_SURFACEERRCHK_H )
#define BX_SURFACEERRCHK_H

#include "bxCore.h"
#include "bxCoreSub.h"



class BxSurfaceErrChkVertex {
public:
	struct InfoVertex {
		BxVec3  vertexPos;
		BxDir   boundRot;
	};
	struct InfoWingEdge {
		BxVec3  wingVec;
		BxVec3  wingNormal[ 2 ];
		BxDir   wingBoundRot;
		bool    wingPairEnable;
		bool    wingPairEnableBHandle;
		BxVec3  wingPairNormal[ 2 ];
	};
	struct InfoWing {
		InfoWingEdge  edge[ 2 ];
	};

public:
	InfoVertex  vertex[ 2 ];
	bool        pairEnable;
	bool        pairEnableBHandle;
	InfoWing    wing[ 2 ];

public:
	BxErr
	IsEnable( bool& isEnable );
	BxErr
	IsEnable( const short beginEndNo, bool& isEnable );

	static const double
	MinAngSinTwoHandle();
	static const double
	MaxAngSinTwoHandle();
	static const double
	MaxAngCosRadialToHandle();
	static const double
	MaxAngSinPairNormal();
	static const double
	MaxAngCosEdgeNormal();
	static const BxDir&
	MaxAngBoundRot();

private:
	BxErr
	IsEnableSub0( bool& isEnable );
	BxErr
	IsEnableSub00( const short beginEndNo, bool& isEnable );

private:
	void
	IsEnableVertexPos( bool& isEnable );
	void
	IsEnablePairNormal( bool& isEnable );
	BxErr
	IsEnableEdgeNormal( bool& isEnable );
	BxErr
	IsEnableBoundRot( bool& isEnable );
	BxErr
	IsEnableRadial( bool& isEnable );

private:
	BxErr
	IsEnableRadialSub( const BxVec3 normal[ 2 ], const BxVec3& radialVec0, const BxDir& boundRot,
		const bool pairEnableBHandle, const BxVec3 pairNormal[ 2 ], bool& isEnable );
};


class BxSurfaceErrChk {
public:
	int                    numVertex;
	BxSurfaceErrChkVertex  vertex[ 4 ];

public:
	void
	Conv( const BxCore::SurfaceInfo& src );
	BxErr
	IsEnable( bool& isEnable );
	void
	SetPairEnable( BxCore::SurfaceInfo& dst );
};


#endif // if !defined( BX_SURFACEERRCHK_H )

////////
