
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxTri.h */


#if !defined( BX_TRI_H )
#define BX_TRI_H

#include "bxCore.h"
#include "bxSurface.h"


class BxTri {
public:
	enum {
		kTriTypeT,
		kTriTypeR,
		kTriTypeS
	};

public:
	BxErr
	ConvSurface( const BxCore::SurfaceInfoVertex vertex[ 3 ], BxCore::TriPatchInfo& tri );

	void
	TriToPatch4741T( const BxCore::TriPatchInfo& tri, BxSurface::Patch4741& patch );
	void
	TriToPatch4741R( const BxCore::TriPatchInfo& tri, BxSurface::Patch4741& patch );
	void
	TriToPatch4741S( const BxCore::TriPatchInfo& tri, BxSurface::Patch4741& patch );

	int
	GetTriType( const BxVec2& uv );
	void
	PosSurface( const BxCore::TriPatchInfo& tri, const BxVec2& uv, BxVec3& pos );
	void
	NormalSurface( const BxCore::TriPatchInfo& tri, const BxVec2& uv, BxVec3& normalVec );
	void
	DuSurface( const BxCore::TriPatchInfo& tri, const BxVec2& uv, BxVec3& du );
	void
	DvSurface( const BxCore::TriPatchInfo& tri, const BxVec2& uv, BxVec3& dv );

	void
	InitDiv( const int numDiv, BxCore::DivTri& dst );
	BxErr
	Divide( const BxCore::TriPatchInfo& src, BxCore::DivTri& dst );

private:
	void
	PosSurfaceMain( const BxCore::TriPatchInfo& tri, const BxVec2& uv0, BxVec3& pos );
	void
	ConvInputInfo( const BxCore::TriPatchInfo& tri, const BxVec2& srcUV, BxSurface::Patch4741& patchT,
		BxSurface::Patch4741& patchR, BxSurface::Patch4741& patchS, BxVec2& dstUV );
	void
	DuSurfaceMain( const BxCore::TriPatchInfo& tri, const BxVec2& uv0, BxVec3& du );
	void
	DvSurfaceMain( const BxCore::TriPatchInfo& tri, const BxVec2& uv0, BxVec3& dv );

	void
	InitDivFaceBound( const int numDiv, BxCore::InfoDivTri& tri );
	void
	InitDivFaceIn( const int numDiv, BxCore::InfoDivTri& tri );
	void
	DivideBound( const BxCore::TriPatchInfo& src, BxCore::DivTri& dst );
	void
	DivideIn( const BxCore::TriPatchInfo& src, BxCore::DivTri& dst );
	void
	DivideOne( const BxCore::TriPatchInfo& src, const double u, const double v, BxVec3& pos,
		const int numNormal, BxCore::DivVertexFace vertexFace[], BxCore::DivFaceTri face[] );
};


#endif // #if !defined( BX_RECT_H )

////////
