
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxVector.h */


#if !defined( BX_VECTOR_H )
#define BX_VECTOR_H

#include "bxCore.h"


class BxVector {
public:
	BxErr
	Pos( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3 pos[ 4 ] );
	void
	Pos0( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& pos );
	BxErr
	Pos1( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& pos );
	BxErr
	Pos2( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& pos );
	void
	Pos3( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& pos );

	BxErr
	Handle( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3 vec[ 4 ] );
	BxErr
	Handle0( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );
	BxErr
	Handle1( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );
	BxErr
	Handle2( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );
	BxErr
	Handle3( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );

	BxErr
	AntiHandle( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3 vec[ 2 ] );
	BxErr
	AntiHandle0( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );
	BxErr
	AntiHandle3( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );

	BxErr
	Tan( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3 vec[ 3 ] );
	BxErr
	Tan0( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );
	BxErr
	Tan1( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );
	BxErr
	Tan2( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );

	BxErr
	TriVHandle( const int no, const BxCore::SurfaceInfoVertex vertex[], BxVec3 vec[ 2 ] );
	BxErr
	TriVHandle1( const int no, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );
	BxErr
	TriVHandle2( const int no, const BxCore::SurfaceInfoVertex vertex[], BxVec3& vec );

	BxErr
	Normal1( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& normal );
	BxErr
	Normal2( const int no, const int numVertex, const BxCore::SurfaceInfoVertex vertex[], BxVec3& normal );
};


#endif // #if !defined( BX_VECTOR_H )

////////
