
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxObj.cpp */


#include "bxObj.h"
#include "bxObjSub.h"

using namespace NameBeziex;



BxObj::FaceSetInfo::
FaceSetInfo()
{
	numVertex     = 0;
	numFace       = 0;
	numFaceVertex = 0;

	vertex     = 0;
	faceHeader = 0;
	faceVertex = 0;
}

BxObj::FaceSetInfo::
~FaceSetInfo()
{
	Delete();
}

void  BxObj::FaceSetInfo::
Delete()
{
	if( vertex != 0 )
		delete[] vertex;

	if( faceHeader != 0 )
		delete[] faceHeader;

	if( faceVertex != 0 )
		delete[] faceVertex;

	numVertex     = 0;
	numFace       = 0;
	numFaceVertex = 0;

	vertex     = 0;
	faceHeader = 0;
	faceVertex = 0;
}


// --------

BxObj::
BxObj()
{
	obj = new BxObjSub;
}

BxObj::
~BxObj()
{
	delete obj;
}

BxErr  BxObj::
MakeObj( const FaceSetInfo& src )
{
	return obj->MakeObj( src );
}

BxErr BxObj::
BoundRot()
{
	return obj->BoundRot();
}

BxErr  BxObj::
DivSurface( const int numDiv, FaceSetInfo& dst )
{
	return obj->DivSurface( numDiv, dst );
}


////////
