
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxObj.h */


#if !defined( BX_OBJ_H )
#define BX_OBJ_H

#include "bxMath.h"


class BxObj {
public:
	struct FaceSetInfoFaceVertex {
		int     vertexNo;
		BxVec3  vertexNormal;
	};
	struct FaceSetInfo {
		int                     numVertex;
		int                     numFace;
		int                     numFaceVertex;

		BxVec3*                 vertex;
		int*                    faceHeader;
		FaceSetInfoFaceVertex*  faceVertex;

	public:
		FaceSetInfo();
		~FaceSetInfo();

		void
		Delete();
	};

public:
	class BxObjRoot {
	public:
		virtual BxErr
		MakeObj( const FaceSetInfo& src ) = 0;
		virtual BxErr
		BoundRot() = 0;
		virtual BxErr
		DivSurface( const int numDiv, FaceSetInfo& dst ) = 0;
	};

protected:
	BxObjRoot*  obj;

public:
	BxObj();
	virtual ~BxObj();

	BxErr
	MakeObj( const FaceSetInfo& src );
	BxErr
	BoundRot();
	BxErr
	DivSurface( const int numDiv, FaceSetInfo& dst );
};


#endif // #if !defined( BX_OBJ_H )

////////
