
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxObjDivSurface.h */


#if !defined( BX_OBJDIVSURFACE_H )
#define BX_OBJDIVSURFACE_H

#include "bxObjSub.h"


class BxObjDivSurface {
private:
	struct BNormalInfoFaceVertex {
		BxVec3  bNormal[ 2 ];
	};
	struct BNormalInfo {
		BNormalInfoFaceVertex*  faceVertex;
	};

	struct InfoDivSurface {
		int              numDiv;
		BxCore::DivRect  divRect;
		BxCore::DivTri   divTri;

		int*             vDstVertex;
		int*             bDstVertex;
	};

private:
	const BxObjSub::ObjInfo&  fSrc;
	BxObj::FaceSetInfo&       fDst;

	BNormalInfo               fBNormal;
	InfoDivSurface            fDiv;
	BxObj::FaceSetInfo        fTmp;

	static const BxObjSub::ObjInfo  gDmySrc;	// not used
	static BxObj::FaceSetInfo       gDmyDst;	// not used

private:
	BxObjDivSurface();	// not used

public:
	BxObjDivSurface( const BxObjSub::ObjInfo& src, const int numDiv, BxObj::FaceSetInfo& dst );

	BxErr
	Exec();

private:
	BxErr
	ExecMain0();
	BxErr
	BNormalProc0();
	BxErr
	BNormalOne0( BxObjSub::ObjInfoFaceVertex faceVertex[], BNormalInfoFaceVertex faceVertexEx[],
		const int numVertex );
	BxErr
	MakeSurfaceInfo( const BxObjSub::ObjInfoFaceVertex faceVertex[], const BNormalInfoFaceVertex faceVertexEx[],
		const int numVertex, BxCore::SurfaceInfo& info );
	BxErr
	MakeSurfaceInfoSub0( const BxObjSub::ObjInfoFaceVertex pairFaceVertex[], const int pairVertexInFace,
		const int pairNumVertex, BxCore::SurfaceInfoEdge& info );
	BxErr
	MakeSurfaceInfoSub1( const BxObjSub::ObjInfoFaceVertex pairFaceVertex[], const int pairVertexInFace,
		const int pairNumVertex, BxCore::SurfaceInfoEdge& info );
	BxErr
	BNormalProc1();
	BxErr
	BNormalOne1( BxObjSub::ObjInfoFaceVertex& faceVertex0a, BxObjSub::ObjInfoFaceVertex& faceVertex0b,
		BNormalInfoFaceVertex& faceVertexEx0a, BNormalInfoFaceVertex& faceVertexEx0b );

	BxErr
	ExecMain1();
	void
	Init( int& numFace );
	void
	InitFaceSetInfoEx( int& numFace );
	BxErr
	ExecSub0( const int numFace );
	BxErr
	ExecOne( const BxObjSub::ObjInfoFaceVertex faceVertex[], const BNormalInfoFaceVertex faceVertexEx[],
		const int numVertex, const int numFace );
	BxErr
	DivideProc( const BxCore::PatchRec& patch );
	BxErr
	SetFaceSetInfoEx( const BxObjSub::ObjInfoFaceVertex faceVertex[], const int numVertex, const int numFace );
	BxErr
	SetFaceSetInfoExRect0( const BxObjSub::ObjInfoFaceVertex faceVertex[], int& faceTop );
	BxErr
	SetFaceSetInfoExRect1( const BxObjSub::ObjInfoFaceVertex faceVertex[], const int faceTop, const int numFace );
	BxErr
	SetFaceSetInfoExTri0( const BxObjSub::ObjInfoFaceVertex faceVertex[], int& faceTop );
	BxErr
	SetFaceSetInfoExTri1( const BxObjSub::ObjInfoFaceVertex faceVertex[], const int faceTop, const int numFace );
	BxErr
	SetFaceSetInfoExSub1( const BxObjSub::ObjInfoFaceVertex faceVertex[], const BxCore::DivFace&  vertex,
		const int faceTop );
	BxErr
	GetEdgeNo( const BxObjSub::ObjInfoFaceVertex& faceVertex, int& edgeNo, bool& reverse );
	BxErr
	ExecSub1();
};


#endif // #if !defined( BX_OBJDIVSURFACE_H )

////////
