
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxObjMakeObj.h */


#if !defined( BX_OBJMAKEOBJ_H )
#define BX_OBJMAKEOBJ_H

#include "bxObjSub.h"


class BxObjMakeObj {
private:
	struct SortInfo {
		int                 faceNo;
		int                 vertexInFace;
		BxObjSub::ObjInfo*  objInfo;
	};

	struct InfoVertexInFace {
		int  ofs;
		int  num;
	};

private:
	const BxObj::FaceSetInfo&  fSrc;
	BxObjSub::ObjInfo&         fDst;

	SortInfo*  fSortInfo;

	static const BxObj::FaceSetInfo  gDmySrc;	// not used
	static BxObjSub::ObjInfo         gDmyDst;	// not used

private:
	BxObjMakeObj();	// not used

public:
	BxObjMakeObj( const BxObj::FaceSetInfo& src, BxObjSub::ObjInfo& dst );

	BxErr
	Exec();

private:
	BxErr
	ExecMain( const int* vertexNoTable );
	BxErr
	Init0( int* vertexNoTable, int& numVertex );
	void
	Alloc( const int numVertex );
	BxErr
	Init1( const int* vertexNoTable );
	void
	Sort();
	BxErr
	Correct( int& numEdge0 );
	int
	GetVertexNo( const SortInfo& sortInfo );
	BxErr
	CorrectSub0( SortInfo sortInfo[], const int num, int& edgeCnt );
	int
	GetVertexNoOne( const SortInfo& sortInfo, const int vertexOfs );
	int
	GetVertexInFace( const SortInfo& sortInfo, const int vertexOfs );
	BxObjSub::ObjInfoFaceVertex&
	GetFaceVertex( const SortInfo& sortInfo, const int vertexOfs );
	void
	PairFaceVertex( const BxObjSub::ObjInfoFaceVertex& src, BxObjSub::ObjInfoFaceVertex& dst );
	void
	CorrectSub00( const SortInfo& sortInfo, const int vertexOfs, const int edgeNo,
		BxObjSub::ObjInfoFaceVertex& faceVertex );
	void
	EdgeProc( const int numEdge0 );

	static int
	SortProc( const void* idt0, const void* idt1 );
};


#endif // #if !defined( BX_OBJMAKEOBJ_H )

////////
