
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxObjSub.cpp */


#include "bxObjSub.h"
#include "bxObjMakeObj.h"
#include "bxObjBoundRot.h"
#include "bxObjDivSurface.h"



BxObjSub::
BxObjSub()
{
	Init();
}

BxObjSub::
~BxObjSub()
{
	Delete();
}

void  BxObjSub::
Init()
{
	info.numVertex     = 0;
	info.numFace       = 0;
	info.numFaceVertex = 0;
	info.numEdge       = 0;

	info.vertex     = 0;
	info.faceHeader = 0;
	info.faceVertex = 0;
	info.edge       = 0;
}

void  BxObjSub::
Delete()
{
	if( info.vertex != 0 )
		delete[] info.vertex;

	if( info.faceHeader != 0 )
		delete[] info.faceHeader;

	if( info.faceVertex != 0 )
		delete[] info.faceVertex;

	if( info.edge != 0 )
		delete[] info.edge;

	Init();
}


// --------

BxErr  BxObjSub::
MakeObj( const BxObj::FaceSetInfo& src )
{
	Delete();

	BxObjMakeObj  makeObj( src, info );
	return makeObj.Exec();
}

BxErr  BxObjSub::
BoundRot()
{
	BxObjBoundRot  boundRot( info );
	return boundRot.Exec();
}

BxErr  BxObjSub::
DivSurface( const int numDiv, BxObj::FaceSetInfo& dst )
{
	dst.Delete();

	BxObjDivSurface  divSurface( info, numDiv, dst );
	return divSurface.Exec();
}


////////
