
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* bxObjSub.h */


#if !defined( BX_OBJSUB_H )
#define BX_OBJSUB_H

#include "bxCore.h"
#include "bxObj.h"


class BxObjSub : public BxObj::BxObjRoot {
public:
	struct ObjInfoFaceVertex {
		int     vertexNo;
		BxVec3  vertexNormal;
		int     pairFaceNo;
		int     pairVertexInFace;
		int     edgeNo;
		BxVec2  ihandle[ 2 ];
	};
	struct ObjInfoEdge {
		BxDir   boundRot;
	};
	struct ObjInfo {
		int                 numVertex;
		int                 numFace;
		int                 numFaceVertex;
		int                 numEdge;

		BxVec3*             vertex;
		int*                faceHeader;
		ObjInfoFaceVertex*  faceVertex;
		ObjInfoEdge*        edge;
	};

private:
	ObjInfo  info;

public:
	BxObjSub();
	virtual ~BxObjSub();

	virtual BxErr
	MakeObj( const BxObj::FaceSetInfo& src );
	virtual BxErr
	BoundRot();
	virtual BxErr
	DivSurface( const int numDiv, BxObj::FaceSetInfo& dst );

private:
	void
	Init();
	void
	Delete();
};


#endif // #if !defined( BX_OBJSUB_H )

////////
