
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* divObjWriteObj.cpp */


#include "divObjWriteObj.h"



DivObjWriteObj::
DivObjWriteObj( const char* fname, BxObj::FaceSetInfo& faceSetInfo )
	: fFname       ( fname ),
	  fFaceSetInfo ( faceSetInfo )
{
	fFp = 0;
}

BxErr  DivObjWriteObj::
Exec()
{
	fFp = fopen( fFname, "wt" );
	if( fFp == 0 )
		return kBxErrFailure;

	VertexProc();
	fprintf( fFp, "\n" );

	NormalProc();
	fprintf( fFp, "\n" );

	FaceProc();

	fclose( fFp );

	return kBxErrSuccess;
}

void  DivObjWriteObj::
VertexProc()
{
	for( int i=0; i<fFaceSetInfo.numVertex; i++ ) {
		fprintf( fFp, "v %g %g %g\n",
			 fFaceSetInfo.vertex[ i ].X(), fFaceSetInfo.vertex[ i ].Y(), fFaceSetInfo.vertex[ i ].Z() );
	}
}

void  DivObjWriteObj::
NormalProc()
{
	int  num;

	int  cnt = 0;
	for( int i=0; i<fFaceSetInfo.numFace; i++ ) {
		if( i == 0 )
			num = fFaceSetInfo.faceHeader[ 0 ];
		else if( i < ( fFaceSetInfo.numFace - 1 ) )
			num = fFaceSetInfo.faceHeader[ i ] - fFaceSetInfo.faceHeader[ i-1 ];
		else
			num = fFaceSetInfo.numFaceVertex - fFaceSetInfo.faceHeader[ i-1 ];

		for( int j=0; j<num; j++ ) {
			fprintf( fFp, "vn %g %g %g\n",
				 fFaceSetInfo.faceVertex[ cnt ].vertexNormal.X(),
				 fFaceSetInfo.faceVertex[ cnt ].vertexNormal.Y(),
				 fFaceSetInfo.faceVertex[ cnt ].vertexNormal.Z() );
			cnt++;
		}
	}
}

void  DivObjWriteObj::
FaceProc()
{
	int  num;

	int  cnt = 0;
	for( int i=0; i<fFaceSetInfo.numFace; i++ ) {
		if( i == 0 )
			num = fFaceSetInfo.faceHeader[ 0 ];
		else if( i < ( fFaceSetInfo.numFace - 1 ) )
			num = fFaceSetInfo.faceHeader[ i ] - fFaceSetInfo.faceHeader[ i-1 ];
		else
			num = fFaceSetInfo.numFaceVertex - fFaceSetInfo.faceHeader[ i-1 ];

		if( num > 0 )
			fprintf( fFp, "f" );

		for( int j=0; j<num; j++ ) {
			fprintf( fFp, " %d//%d",
				 fFaceSetInfo.faceVertex[ cnt ].vertexNo+1, cnt+1 );
			cnt++;
		}

		if( num > 0 )
			fprintf( fFp, "\n" );
	}
}


////////
