
//
// Copyright 2004 Eishin Matsui. All rights reserved.
//
//     first release day : 2004/May/23
//

/* main.cpp */


#include <stdio.h>
#include <stdlib.h>

#include "divObj.h"


static BxErr
GetArg( int argc, char* argv[], char*& readFname, int& numDiv, char*& writeFname );

int
main( int argc, char* argv[] )
{
	BxErr   err;
	char    *readFname, *writeFname;
	int     numDiv;
	DivObj  obj;

	err = GetArg( argc, argv, readFname, numDiv, writeFname );
	if( err == kBxErrFailure ) {
		printf( "sII\n" );
		return 1;
	}

	err = obj.Exec( readFname, numDiv, writeFname );
	if( err == kBxErrFailure ) {
		printf( "sII\n" );
		return 1;
	}

	printf( "II\n" );

	return 0;
}

static BxErr
GetArg( int argc, char* argv[], char*& readFname, int& numDiv, char*& writeFname )
{
	enum {
		kArgCommand,

		kArgReadFname,
		kArgNumDiv,
		kArgWriteFname,

		kNumArg
	};
	enum {
		kMaxNumDiv  = 8
	};

	if( argc != kNumArg )
		return kBxErrFailure;

	readFname = argv[ kArgReadFname ];

	char*  endptr;
	numDiv = strtol( argv[ kArgNumDiv ], &endptr, 10 );
	if( *endptr != '\0' )
		return kBxErrFailure;
	if( 1 > numDiv || numDiv > kMaxNumDiv )
		return kBxErrFailure;

	writeFname = argv[ kArgWriteFname ];

	return kBxErrSuccess;
}


////////
